#line 1 "C:/Users/Corey/Documents/Projects/C_Meter/PIC/C_Meter_PIC.c"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for pic/include/stdbool.h"



 typedef char _Bool;
#line 1 "c:/c4w/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 5 "C:/Users/Corey/Documents/Projects/C_Meter/PIC/C_Meter_PIC.c"
sbit C_METER_RST at RE1_bit;
sbit C_METER_RST_DIR at TRISE1_bit;
sbit C_METER_INT at RB0_bit;
sbit C_METER_INT_DIR at TRISB0_bit;

void system_setup( void );
void setup_interrupt( void );
void InitTimer0( void );

 _Bool  flag;
uint32_t start_val;
uint32_t end_val;
char uart_text[ 40 ];
char final_text[ 40 ];
uint32_t int_count = 0;
uint32_t timer_count_end = 0;
 _Bool  sec_flag =  0 ;
float c_cal = 0.0;
float t_meas = 0.0;
float c_meas = 0.0;
float final = 0.0;
float t_cal = 0.0;


void main()
{

  _Bool  calibration_flag =  1 ;


 system_setup();
 setup_interrupt();
 InitTimer0();

 t_cal = 1.0 / 22189.0;
 c_cal = t_cal / 77616.0;

 int_count = 0;

 while(1)
 {

 if( sec_flag )
 {

 sprintf( uart_text, "Interrupts : %u\r\n", timer_count_end );
 UART1_Write_Text( uart_text );

 t_meas = 1.0 / timer_count_end;
 c_meas = t_meas / 77616.0;
 final = fabs( c_cal - c_meas );

 UART1_Write_Text( "Calibrated: " );
 FloatToStr( c_cal, uart_text );
 UART1_Write_Text( uart_text );
 UART1_Write_Text( "\r\n" );
 UART1_Write_Text( "Final: " );
 FloatToStr( final, final_text );
 UART1_Write_Text( final_text );
 UART1_Write_Text( "\r\n" );

 sec_flag =  0 ;
 int_count = 0;
 timer_count_end = 0;
 }
 }
}

void system_setup( void )
{

 C_METER_INT_DIR = 1;
 C_METER_RST_DIR = 0;


 C_METER_RST = 0;
 Delay_ms(50);
 C_METER_RST = 1;


 UART1_Init( 9600 );
 UART1_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{

 ADCON1 = 0x0F;
 ANSELB = 0;
 TRISB = 0xFF;

 INTEDG0_bit = 0;
 INT0IF_bit = 0;
 INT0IE_bit = 1;
 GIE_bit = 1;
}

void InitTimer0(){
 T0CON = 0x84;
 TMR0H = 0x0B;
 TMR0L = 0xDC;
 GIE_bit = 1;
 TMR0IE_bit = 1;
}

void Interrupt()
{
 if (INT0IF_bit && INT0IE_bit)
 {
 INT0IF_bit = 0;
 INT0IE_bit = 0;

 int_count++;
 INT0IE_bit = 1;
 }

 if (TMR0IF_bit)
 {
 TMR0IF_bit = 0;
 TMR0H = 0x0B;
 TMR0L = 0xDC;

 timer_count_end = int_count;
 int_count = 0;
 sec_flag =  1 ;
 }


}
